C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C CIRCUL.FOR - 24.09.2019 - OpenWatcom FORTRAN
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Copyright (c) 2009-2019 Nikolitsa Giannopoulou OE3ZGN|SV7DMC and      
C Petros Zimourtopoulos OE3ZZP|SV7BAX - Austria EU - www.op4.eu -       
C                                                                       
C Permission is hereby granted, free of charge, to any person obtaining 
C a copy of this software and associated documentation files (the       
C "Software"), to deal in the Software without restriction, including   
C distribute, sublicense, and/or sell copies of the Software, and to    
C permit persons to whom the Software is furnished to do so, subject to 
C the following conditions:                                             
C                                                                      
C The above copyright notice and this permission notice shall be        
C included in all copies or substantial portions of the Software.       
C                                                                       
C THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       
C EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    
C MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
C IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY  
C CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,  
C TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE     
C SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C /F/L/O/S/S/ Free Libre Open Source Software under "The MIT License"   
C approved by OSI Open Source Initiative www.opensource.org/licenses/MIT
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Current Version : 20190924 - OpenWatcom : 1.9 
C First   Version : 20093003 - OpenWatcom : 1.8 
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C2345678901234567890123456789012345678901234567890123456789012345VENEX72
      SUBROUTINE CIRCUL(NL,RHO,LL,DL,RHOLA,LLARRA,CIRCLE,LINE)
      INTEGER    I,J,NL,M,LINE
      REAL       DL,PI,FL,E0,ARHOL,CIRCLE,E
      REAL       IM1,RE1,IM2,RE2,K,KK,E2,E3,TEMP
      COMPLEX    LLARRA,LL,RHOLA,E4,FLL,RHO,LLTEMP
      DIMENSION  LLARRA(48),LL(48),FLL(48),FL(2),LLTEMP(48)
      DIMENSION  K(2),KK(3),E3(3),CIRCLE(24,7),LINE(24,2)
      INTEGER    N
      REAL       F1,F2
C      
      PI=3.141592654  
      E2=0.0
      E4=CMPLX(0.0,0.0)
      DO 1 I=1,2,1      
    1 FL(I) =0.0
      DO 2 I=1,3,1
      KK(I)=0.0
    2 E3(I)=0.0
      DO 3 I=1,2,1
    3 K(I)=0.0
      DO 4 I=1,24,1
      DO 4 J=1,7,1
    4 CIRCLE(I,J)=0.0
      DO 5 I=1,24,1
      DO 5 J=1,2,1
    5 LINE(I,J)=0
      DO 6 I=1,48,1
    6 LLTEMP(I)=CMPLX(0.,0.)
      DO 7 I=1,NL,1
      LLTEMP(I)=LL(I)+RHO
    7 CONTINUE
      LLTEMP(NL+1)=LL(1)+RHO
      DO 8 I=1,NL+1,1
    8 LL(I)=LLTEMP(I)
C    
      ARHOL=CABS(RHOLA)
      E0=ARHOL*DL
C
      LL(NL+1)=LL(1)
      N=0
      M=1
      DO 10 I=1,NL,1
      IM1=IMAG(LL(I))
      RE1=REAL(LL(I))
      IM2=IMAG(LL(I+1))
      RE2=REAL(LL(I+1))
      IF ((RE1.EQ.RE2).AND.(IM1.EQ.IM2)) THEN
      WRITE(6,*)'E R R O R   IN   P O I N T S'
      ELSE
      IF (IM1.NE.IM2) THEN
      E2=-(RE2-RE1)/(IM2-IM1)
      K(1)=1/SQRT(1+E2**2)
      K(2)=E2/SQRT(1+E2**2)
      KK(1)=K(1)
      KK(2)=K(2)
      KK(3)=0.0
      ELSE
      K(1)=0.0
      K(2)=1.0
      KK(1)=K(1)
      KK(2)=K(2)
      KK(3)=0.0
      ENDIF
C     CROSS PRODUCT
      E3(1)=-KK(3)*(IM2-IM1)
      E3(2)=KK(3)*(RE2-RE1)
      E3(3)=KK(1)*(IM2-IM1)-KK(2)*(RE2-RE1)
      IF (E3(3).LT.0.) THEN
      E4=CMPLX(-K(1),-K(2))
      ELSE
      E4=CMPLX(K(1),K(2)) 
      ENDIF
      LLARRA(M)=LL(I)+E0*E4
      LLARRA(M+1)=LL(I+1)+E0*E4
      ENDIF
      M=M+2
      N=N+1
   10 CONTINUE 
C
      M=2
      FLL(1)=LLARRA(1)-LL(1)
      J=2
      DO 20 I=2,NL,1
      FLL(J)=LLARRA(M)-LL(I)
      FLL(J+1)=LLARRA(M+1)-LL(I)
      M=M+2
      J=J+2
   20 CONTINUE         
      FLL(2*N)=LLARRA(2*N)-LL(1)
C
C     CIRCLE DATA
      DO 30 I=1,24,1
      CIRCLE(I,5)=E0
   30 CONTINUE
C     THE FIRST ARC BETWEEN POINT-48 AND POINT-1 C
      IM1=IMAG(FLL(1))
      RE1=REAL(FLL(1))
      F1=ATAN2(IM1,RE1)
      IM2=IMAG(FLL(2*N))
      RE2=REAL(FLL(2*N))
      F2=ATAN2(IM2,RE2)
      IF (F1.LE.F2) THEN
      FL(1)=F1
      FL(2)=F2
      ELSE
      FL(1)=F2
      FL(2)=F1
      ENDIF
      IF ((PI/2.LE.FL(2)).AND.(FL(2).LE.PI).AND.(-PI.LT.FL(1)).AND.
     *(FL(1).LE.(-PI/2))) THEN
      TEMP=FL(1)
      FL(1)=FL(2)
      FL(2)=2*PI+TEMP
      ENDIF
      IF (FL(1).GT.FL(2)) THEN
      TEMP=FL(1)
      FL(1)=FL(2)
      FL(2)=TEMP
      ENDIF
      RE1=REAL(LL(1))
      IM1=IMAG(LL(1))
      CIRCLE(1,1)=2*N
      CIRCLE(1,2)=1
      CIRCLE(1,3)=RE1
      CIRCLE(1,4)=IM1
      CIRCLE(1,6)=FL(1)
      CIRCLE(1,7)=FL(2)
C     THE REST ARCS
      M=2
      DO 40 I=2,NL,1  
      IM1=IMAG(FLL(M))
      RE1=REAL(FLL(M))
      F1=ATAN2(IM1,RE1)
      IM2=IMAG(FLL(M+1))
      RE2=REAL(FLL(M+1))
      F2=ATAN2(IM2,RE2)
      IF (F1.LE.F2) THEN
      FL(1)=F1
      FL(2)=F2
      ELSE
      FL(1)=F2
      FL(2)=F1
      ENDIF
      IF ((PI/2.LE.FL(2)).AND.(FL(2).LE.PI).AND.(-PI.LT.FL(1)).AND.
     *(FL(1).LE.(-PI/2))) THEN
      TEMP=FL(1)
      FL(1)=FL(2)
      FL(2)=2*PI+TEMP
      ENDIF
      RE1=REAL(LL(I))
      IM1=IMAG(LL(I))
      CIRCLE(I,1)=M
      CIRCLE(I,2)=M+1
      CIRCLE(I,3)=RE1
      CIRCLE(I,4)=IM1
      CIRCLE(I,6)=FL(1)
      CIRCLE(I,7)=FL(2)
      M=M+2
   40 CONTINUE
      NL=2*N
      M=1
      DO 50 I=1,NL,2
      LINE(M,1)=I
      LINE(M,2)=I+1
      M=M+1  
   50 CONTINUE 
      E=10.**(-7)
      DO 60 I=1,NL,1
      RE1=ABS(REAL(LLARRA(I)))
      IM1=ABS(IMAG(LLARRA(I)))
      IF((RE1.LT.E).AND.(IM1.LT.E))LLARRA(I)=CMPLX(0.,0.)
   60 CONTINUE
      END

