C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C COEFFI.FOR - 24.09.2019 - OpenWatcom FORTRAN
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Copyright (c) 2009-2019 Nikolitsa Giannopoulou OE3ZGN|SV7DMC and      
C Petros Zimourtopoulos OE3ZZP|SV7BAX - Austria EU - www.op4.eu -       
C                                                                       
C Permission is hereby granted, free of charge, to any person obtaining 
C a copy of this software and associated documentation files (the       
C "Software"), to deal in the Software without restriction, including   
C distribute, sublicense, and/or sell copies of the Software, and to    
C permit persons to whom the Software is furnished to do so, subject to 
C the following conditions:                                             
C                                                                      
C The above copyright notice and this permission notice shall be        
C included in all copies or substantial portions of the Software.       
C                                                                       
C THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       
C EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    
C MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
C IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY  
C CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,  
C TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE     
C SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C /F/L/O/S/S/ Free Libre Open Source Software under "The MIT License"   
C approved by OSI Open Source Initiative www.opensource.org/licenses/MIT
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Current Version : 20190924 - OpenWatcom : 1.9 
C First   Version : 20093003 - OpenWatcom : 1.8 
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C2345678901234567890123456789012345678901234567890123456789012345VENEX72
      SUBROUTINE COEFFI(STE,LTE,OTE,METE,
     *                  RHOMMA,RHOSMA,RHOLMA,RHOOMA,
     *                  RHOMMF,RHOSMF,RHOLMF,RHOOMF,
     *                  RHOSF, RHOOF, RHOSA, RHOLA,RHOOA,
     *                  D,M,R,RHO)                 
      COMPLEX STE,OTE,LTE,METE
      COMPLEX D,CDL,CDLM
      COMPLEX M,CMS,CML,CMO,CMSM,CMLM,CMOM 
      COMPLEX R,CRS,CRL,CRO,CRSM,CRLM,CROM
      COMPLEX RHO,RHOS,RHOL,RHOO,RHOSM,RHOLM,RHOOM,RHOMM
      COMPLEX RHODEN,DEN
      COMPLEX RHOMMA,RHOSMA,RHOLMA,RHOOMA
      COMPLEX RHOMMF,RHOSMF,RHOLMF,RHOOMF
      COMPLEX RHOSA, RHOLA, RHOOA, RHOSF,RHOOF
C
      DEN=(OTE-STE)
      D=LTE
      M=(OTE+STE-2*LTE)/DEN
      R=2*(STE-LTE)*(LTE-OTE)/DEN
C
      CDL=-2*(STE-LTE)*(LTE-OTE)/DEN
      CDLM=1.0
C
      CMS =(STE-LTE)/DEN
      CML =4*(LTE-OTE)*(STE-LTE)/(DEN**2)
      CMO =(LTE-OTE)/DEN
      CMSM=-2*(LTE-OTE)/(DEN**2)
      CMLM=-2/DEN
      CMOM=-2*(STE-LTE)/(DEN**2)
C
      CRS =(STE-LTE)*(LTE-OTE)/DEN
      CRL =4*((OTE-STE)+2*(LTE-OTE))*(STE-LTE)*(LTE-OTE)/(DEN**2)
      CRO =-(STE-LTE)*(LTE-OTE)/DEN
      CRSM=-2*(LTE-OTE)**2/(DEN**2)
      CRLM=-2*((OTE-STE)+2*(LTE-OTE))/DEN
      CROM=2*(STE-LTE)**2/(DEN**2)
C
      RHODEN=M*(METE-D)+R
      RHO=(METE-D)/RHODEN
      RHOS=(-((METE-D)**2)*CMS-(METE-D)*CRS)/RHODEN**2
      RHOL=(-R*CDL-((METE-D)**2)*CML-(METE-D)*CRL)/RHODEN**2
      RHOO=(-((METE-D)**2)*CMO-(METE-D)*CRO)/RHODEN**2
      RHOSM=(-((METE-D)**2)*CMSM-(METE-D)*CRSM)/RHODEN**2
      RHOLM=(-R*CDLM-((METE-D)**2)*CMLM-(METE-D)*CRLM)/RHODEN**2
      RHOOM=(-((METE-D)**2)*CMOM-(METE-D)*CROM)/RHODEN**2
      RHOMM=R/RHODEN**2
C      
      RHOMMA=(LOG(10.)/20.)*RHOMM*METE   
      RHOSMA=(LOG(10.)/20.)*RHOSM*STE    
      RHOLMA=(LOG(10.)/20.)*RHOLM*LTE     
      RHOOMA=(LOG(10.)/20.)*RHOOM*OTE    
      RHOMMF=RHOMM*METE*CMPLX(0.0,1.0)   
      RHOSMF=RHOSM*STE*CMPLX(0.0,1.0)    
      RHOLMF=RHOLM*LTE*CMPLX(0.0,1.0)        
      RHOOMF=RHOOM*OTE*CMPLX(0.0,1.0)      
      RHOSF=RHOS*(-1.0)*CMPLX(0.0,1.0)    
      RHOOF=RHOO*1.0*CMPLX(0.0,1.0)        
      RHOSA=RHOS*(-1.0)                  
      RHOLA=RHOL 
      RHOOA=RHOO*1.0                      
C     dmdb,dsdb,dldb,dodb,dfm,dfs,dfl,dfo,dfS,dfO,dS,dL,dO
      END
