C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C HALFOR.FOR - 24.09.2019 - OpenWatcom FORTRAN
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Copyright (c) 2009-2019 Nikolitsa Giannopoulou OE3ZGN|SV7DMC and      
C Petros Zimourtopoulos OE3ZZP|SV7BAX - Austria EU - www.op4.eu -       
C                                                                       
C Permission is hereby granted, free of charge, to any person obtaining 
C a copy of this software and associated documentation files (the       
C "Software"), to deal in the Software without restriction, including   
C distribute, sublicense, and/or sell copies of the Software, and to    
C permit persons to whom the Software is furnished to do so, subject to 
C the following conditions:                                             
C                                                                      
C The above copyright notice and this permission notice shall be        
C included in all copies or substantial portions of the Software.       
C                                                                       
C THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       
C EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    
C MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
C IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY  
C CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,  
C TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE     
C SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C /F/L/O/S/S/ Free Libre Open Source Software under "The MIT License"   
C approved by OSI Open Source Initiative www.opensource.org/licenses/MIT
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Current Version : 20190924 - OpenWatcom : 1.9 
C First   Version : 20093003 - OpenWatcom : 1.8 
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C2345678901234567890123456789012345678901234567890123456789012345VENEX72
      SUBROUTINE HALFOR(NL,LL,DX,RHOXA,LLARRA)
      REAL DPL
      REAL DX
      COMPLEX RHOXA
      REAL LARRAY,FL,E1,FL2,E3,E11
      DIMENSION LARRAY(48,2),FL(48),E1(48),FL2(48),E11(48)
      DIMENSION LLARRA(48),P3(48),E3(48),H3(48),K4(48),K5(48),LL(48)
      COMPLEX LLARRA,H3,E0,LL
      INTEGER I,II,J,K,KK,NL,P3,E2,E22,K4,K5,P41,P31,P4,P31T,M
      REAL TEMP,IM,RE,PI,MAX,E0ARG,K2,P5
      DIMENSION K2(2),P4(48),P41(48),P31(48),P31T(48),P5(2)
C     
      PI=3.141592654  
      DO 1 I=1,48,1
      DO 1 J=1,2,1
      LARRAY(I,J)=0.0
    1 CONTINUE
      DO 2 I=1,48,1      
      FL(I) =0.0
      FL2(I)=0.0
      E1(I) =0.0
      E11(I)=0.0
      P3(I) =0
      P4(I)=0
      P31(I)=0
      P31T(I)=0
      P41(I)=0
      E3(I)=0.0
      K4(I)=0
      K5(I)=0
      H3(I)=CMPLX(0.0,0.0)
    2 CONTINUE      
C     NL : THE NUMBER OF COMPLEX NUMBES-POINTS
      IM=0.
      RE=0.
      DO 100 I=1,NL,1
      IM=IMAG(LL(I))
      RE=REAL(LL(I))
      FL(I)=ATAN2(IM,RE)
      LARRAY(I,1)=RE
      LARRAY(I,2)=IM
  100 CONTINUE
      E0=RHOXA*DX
      E0ARG=ATAN2(IMAG(E0),REAL(E0))
      IF ((0.LT.E0ARG).AND.(E0ARG.LE.PI)) THEN
      K2(1)=E0ARG-PI
      K2(2)=E0ARG
      ELSE
      K2(1)=E0ARG
      K2(2)=E0ARG+PI
      ENDIF
C      
      J=1
      II=1
      DO 110 I=1,NL,1
      IF((K2(1).LE.FL(I)).AND.(FL(I).LE.K2(2)))THEN
      K4(J)=I
      J=J+1
      ELSE
      K5(II)=I
      II=II+1
      ENDIF
  110 CONTINUE
C
      J=J-1
      II=II-1
      DO 120 I=1,J,1
      K=K4(I)
      E1(I)=DPL(LARRAY(K,1),LARRAY(K,2),REAL(E0),IMAG(E0))
  120 CONTINUE
      E2=1
      MAX=0.0
      DO 130 I=1,NL,1
      TEMP=E1(I)
      IF (TEMP.GT.MAX) THEN
      MAX=TEMP
      E2=I
      ENDIF
  130 CONTINUE
C
      DO 140 I=1,II,1
      K=K5(I)
      E11(I)=DPL(LARRAY(K,1),LARRAY(K,2),REAL(E0),IMAG(E0))
  140 CONTINUE
      E22=1
      MAX=0.0
      DO 150 I=1,II,1
      TEMP=E11(I)
      IF (TEMP.GT.MAX) THEN
      MAX=TEMP
      E22=I
      END IF
  150 CONTINUE
C
      IF (FL(K4(E2)).GT.FL(K5(E22))) THEN
      P5(1)=FL(K5(E22))
      P5(2)=FL(K4(E2))
      ELSE
      P5(1)=FL(K4(E2))
      P5(2)=FL(K5(E22))
      ENDIF
C
      II=0
      J=0
      DO 160 I=1,NL,1
      IF ((P5(1).LE.FL(I)).AND.(FL(I).LE.P5(2))) THEN
      II=II+1
      P3(II)=I
      ELSE
      J=J+1
      P4(J)=I
      ENDIF
  160 CONTINUE
C
      DO 170 I=1,J,1
  170 P41(I)=P4(I)
      P41(J+1)=K4(E2)
      P41(J+2)=K5(E22)
      J=J+2
      KK=0
      DO 180 I=1,NL,1
  180 P31T(I)=I
C     
      K=1  
      DO 190 KK=1,NL,1
      M=P31T(KK)
      DO 190 I=1,J,1
      IF (P4(I).EQ.M)THEN 
      P31T(P4(I))=0
      K=K+1
      ENDIF
  190 CONTINUE
      KK=NL-(K-1)
      K=1
      DO 200 I=1,NL,1
      M=P31T(I)
      IF (M.NE.0) THEN
      P31(K)=M
      K=K+1
      ENDIF
  200 CONTINUE
C
      IF ((P5(1).LE.E0ARG).AND.(E0ARG.LE.P5(2))) THEN
      DO 210 I=1,II,1
      H3(I)=E0+LL(P3(I))
  210 CONTINUE
      NL=J+II
      K=1
      DO 220 I=II+1,NL,1
      H3(I)=LL(P41(K))
      K=K+1
  220 CONTINUE
C
      ELSE
      NL=J+KK
      DO 230 I=1,J,1
      H3(I)=E0+LL(P41(I))
  230 CONTINUE
      K=1
      DO 240 I=J+1,NL,1
      H3(I)=LL(P31(K))
      K=K+1
  240 CONTINUE
      ENDIF
      DO 250 I=1,NL,1
      LLARRA(I)=H3(I)
  250 CONTINUE
      END
