C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C PODEIS.FOR - 24.09.2019 - OpenWatcom FORTRAN
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Copyright (c) 2009-2019 Nikolitsa Giannopoulou OE3ZGN|SV7DMC and      
C Petros Zimourtopoulos OE3ZZP|SV7BAX - Austria EU - www.op4.eu -       
C                                                                       
C Permission is hereby granted, free of charge, to any person obtaining 
C a copy of this software and associated documentation files (the       
C "Software"), to deal in the Software without restriction, including   
C distribute, sublicense, and/or sell copies of the Software, and to    
C permit persons to whom the Software is furnished to do so, subject to 
C the following conditions:                                             
C                                                                      
C The above copyright notice and this permission notice shall be        
C included in all copies or substantial portions of the Software.       
C                                                                       
C THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       
C EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    
C MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
C IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY  
C CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,  
C TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE     
C SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C /F/L/O/S/S/ Free Libre Open Source Software under "The MIT License"   
C approved by OSI Open Source Initiative www.opensource.org/licenses/MIT
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Current Version : 20190924 - OpenWatcom : 1.9 
C First   Version : 20093003 - OpenWatcom : 1.8 
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C2345678901234567890123456789012345678901234567890123456789012345VENEX72
      SUBROUTINE PODEIS(RHO,LLARRA,CIRCLE,LINE,
     *                  MINM,MAXM,MINA,MAXA)
      INTEGER I,J,K,LINE,SGN,SUM
      REAL MINM,MAXM,MINA,MAXA,MINAA,MAXAA,MIN1,MAX1
      REAL VALUE,PHASE,CIRCLE,PI,ARG,E,ALFA,PHMIN,PHMAX
      REAL RE1,RE2,IM1,IM2,METRO,RTR,RTI,LU,TA,TT,T
      COMPLEX LLARRA,TEMP,RHO
      DIMENSION LLARRA(48),LU(2),ARG(1000),PHMIN(1000),PHMAX(1000)
      DIMENSION CIRCLE(24,7),LINE(24,2),SGN(4)
C
      PI=3.141592654
      RE1=0.0
      IM1=0.0
      RE2=0.0
      IM2=0.0
      METRO=0.0
      VALUE=0.0
      PHASE=0.0
      RTR=0.0
      RTI=0.0
      TA=0.0
      TT=0.0
      SUM=0
      ALFA=0.
      TEMP=CMPLX(0.0,0.0)
      DO 1 I=1,2,1
    1 LU(I)=0.0      
      DO 2 I=1,1000,1
    2 ARG(I)=0.0
      DO 3 I=1,4,1
    3 SGN(I)=0
      MAXM=-99999999
      MAXA=-99999999
      MINM=99999999
      MINA=99999999
      MINAA=-99999999
      MAXAA=99999999
      MIN1=0.
      MAX1=0.
      DO 5 I=1,48,1
      RE1=REAL(LLARRA(I))
      IM1=IMAG(LLARRA(I))
      IF ((RE1.GT.0).AND.(IM1.GT.0))THEN
      SGN(1)=1
      ELSEIF ((RE1.LT.0).AND.(IM1.GT.0))THEN
      SGN(2)=2
      ELSEIF ((RE1.LE.0).AND.(IM1.LE.0))THEN
      SGN(3)=3
      ELSEIF ((RE1.GT.0).AND.(IM1.LT.0))THEN
      SGN(4)=4
      ENDIF
      SUM=SGN(1)+SGN(2)+SGN(3)+SGN(4)
    5 CONTINUE
C   
      K=1
      DO 10 I=1,24,1
      RE1=REAL(LLARRA(LINE(I,1)))
      IM1=IMAG(LLARRA(LINE(I,1)))
      RE2=REAL(LLARRA(LINE(I,2)))
      IM2=IMAG(LLARRA(LINE(I,2)))
      METRO=SQRT((RE2-RE1)*(RE2-RE1)+(IM2-IM1)*(IM2-IM1))
      LU(1)=(RE2-RE1)/METRO
      LU(2)=(IM2-IM1)/METRO
      DO 10 J=1,31,1
      RTR=RE1+METRO*(J-1)*LU(1)/30
      RTI=IM1+METRO*(J-1)*LU(2)/30
      E=10.**(-7)
      IF((ABS(RTR).LT.E).AND.(ABS(RTI).LT.E))THEN
      RTR=0.
      RTI=0.
      ENDIF
      VALUE=SQRT(RTR*RTR+RTI*RTI)
      IF(VALUE.LT.MINM)MINM=VALUE
      IF(VALUE.GT.MAXM)MAXM=VALUE
      PHASE=ATAN2(RTI,RTR)
      ARG(K)=PHASE
C
      IF((PHASE.EQ.0).AND.(RTR.EQ.0))THEN
      IF(J.NE.1)ALFA=ARG(K-1)
      IF(J.EQ.1)THEN
      RTR=RE1+METRO*LU(1)/30
      RTI=IM1+METRO*LU(2)/30
      ALFA=ATAN2(RTI,RTR)
      ENDIF
C      WRITE(6,*)J,ALFA
      PHASE=ATAN2(IMAG(RHO),REAL(RHO))
      CALL ZEROBO(PHASE,ALFA,MINA,MAXA)
      GOTO 11
      ENDIF
C
      K=K+1
      IF(PHASE.GT.MAXA)MAXA=PHASE
      IF(PHASE.LT.MINA)MINA=PHASE
   10 CONTINUE
C      
      K=K-1
      IF((MINA.GT.(-PI)).AND.(MINA.LT.(-PI/2)).AND.(MAXA.GT.PI/2).AND.
     *(MAXA.LE.PI)) THEN
      CALL SOARCS(K,ARG,PHMIN,PHMAX,MINAA,MAXAA)
      MIN1=MINAA
      MAX1=MAXAA
      ENDIF
C
   11 K=1
      DO 20 I=1,24,1
      TA=CIRCLE(I,6)
      TT=CIRCLE(I,7)
C    (LENGTH OF THE ARC TA,TT)      
      METRO=TT-TA 
      DO 20 J=1,31,1
      T=TA+METRO*(J-1)/30
      RTR=CIRCLE(I,3)+CIRCLE(I,5)*COS(T)
      RTI=CIRCLE(I,4)+CIRCLE(I,5)*SIN(T)
      E=10.**(-7)
      IF((ABS(RTR).LT.E).AND.(ABS(RTI).LT.E))THEN
      RTR=0.
      RTI=0.
      ENDIF
      VALUE=SQRT(RTR*RTR+RTI*RTI)
      IF (VALUE.LT.MINM)MINM=VALUE
      IF (VALUE.GT.MAXM)MAXM=VALUE
      PHASE=ATAN2(RTI,RTR)
      ARG(K)=PHASE
      K=K+1
      IF (ALFA.NE.0)GOTO 20
      IF((PHASE.EQ.0).AND.(RTR.EQ.0))THEN
      IF(J.NE.1)ALFA=ARG(K-2)
      IF(J.EQ.1)THEN
      RTR=CIRCLE(I,3)+CIRCLE(I,5)*COS(TA+METRO/30)
      RTI=CIRCLE(I,4)+CIRCLE(I,5)*SIN(TA+METRO/30)
      ALFA=ATAN2(RTI,RTR)
      ENDIF
      PHASE=ATAN2(IMAG(RHO),REAL(RHO))
      CALL ZEROBO(PHASE,ALFA,MINA,MAXA)
      GOTO 21
      ENDIF
      IF (PHASE.LT.MINA)MINA=PHASE
      IF (PHASE.GT.MAXA)MAXA=PHASE
   20 CONTINUE
C     CHECK: IF REGION CONTAINS O (BEGINNING OF THE SYSTEM)     
   21 IF (SUM.EQ.10)THEN
      MINM=MAXM
      MINA=0
      MAXA=2*PI
      GOTO 300
      ENDIF
C
      IF(ALFA.NE.0)GOTO 300
      K=K-1
      IF((MINA.GT.(-PI)).AND.(MINA.LT.(-PI/2)).AND.(MAXA.GT.PI/2).AND.
     *(MAXA.LE.PI))CALL SOARCS(K,ARG,PHMIN,PHMAX,MINAA,MAXAA)
C
      IF ((MINAA.LT.MIN1).AND.(MINAA.NE.(-99999999)))MIN1=MINAA
      IF ((MAXAA.GT.MAX1).AND.(MAXAA.NE.99999999))MAX1=MAXAA
C
      PHASE=ATAN2(IMAG(RHO),REAL(RHO))
      IF((PHASE.GT.(-PI)).AND.(PHASE.LT.(-PI/2)))GOTO 100
      IF((PHASE.GT.PI/2).AND.(PHASE.LE.PI))GOTO 200
      GOTO 300
C    (STRECHED TO THE NEGATIVE)
  100 IF (((MAX1-2*PI).LT.MIN1).AND.(MAX1.NE.99999999).AND.(MAX1.NE.0.))
     *THEN
      MINA=MAX1-2*PI
      MAXA=MIN1
      ELSEIF((MIN1.LT.(MAX1-2*PI)).AND.(MIN1.NE.(-99999999)).AND.(MIN1.
     *NE.0.))THEN
      MINA=MIN1
      MAXA=MAX1-2*PI
      ENDIF
      GOTO 300
C    (STRECHED TO THE POSITIVE)
  200 IF (((MIN1+2*PI).LT.MAX1).AND.(MIN1.NE.(-99999999)).AND.(MIN1.NE
     *.0.))THEN
      MINA=MIN1+2*PI
      MAXA=MAX1
      ELSEIF(((MIN1+2*PI).GT.MAX1).AND.(MAX1.NE.99999999).AND.(MAX1.NE
     *.0.))THEN
      MINA=MAX1
      MAXA=MIN1+2*PI
      ENDIF
C    
  300 CONTINUE
      END
