C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C REGION.FOR - OpenWatcom FORTRAN
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Copyright (c) 2009-2019 Nikolitsa Giannopoulou OE3ZGN|SV7DMC and      
C Petros Zimourtopoulos OE3ZZP|SV7BAX - Austria EU - www.op4.eu -       
C                                                                       
C Permission is hereby granted, free of charge, to any person obtaining 
C a copy of this software and associated documentation files (the       
C "Software"), to deal in the Software without restriction, including   
C distribute, sublicense, and/or sell copies of the Software, and to    
C permit persons to whom the Software is furnished to do so, subject to 
C the following conditions:                                             
C                                                                      
C The above copyright notice and this permission notice shall be        
C included in all copies or substantial portions of the Software.       
C                                                                       
C THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       
C EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    
C MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
C IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY  
C CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,  
C TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE     
C SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C /F/L/O/S/S/ Free Libre Open Source Software under "The MIT License"   
C approved by OSI Open Source Initiative www.opensource.org/licenses/MIT
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Current Version : 20190924 - OpenWatcom : 1.9 
C First   Version : 20093003 - OpenWatcom : 1.8 
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C2345678901234567890123456789012345678901234567890123456789012345VENEX72
      PROGRAM REGION 
C     IMPLICIT NONE
      INTEGER I,J,NF,NL,NLB,LINE,INDEX   
      REAL VALUE,PHASE,PI,F,FF,CIRCLE,Z0
      REAL DMDB(500),DSDB(500),DLDB(500),DODB(500)
      REAL DFMM(500),DFSM(500),DFLM(500),DFOM(500)
      REAL DS,DL,DOO,DFS,DFO,DIGIT
      REAL MINR,MAXR,MINI,MAXI,MINM,MAXM,MINA,MAXA
      COMPLEX CPHASE
      COMPLEX S,O,L,ME
      DIMENSION S(500),O(500),L(500),ME(500)
      COMPLEX STEMP,OTEMP,LTEMP,METEMP
      COMPLEX D,M,R,RHO,ZETA,ZI,RHOZET
      COMPLEX RHOMMA,RHOSMA,RHOLMA,RHOOMA
      COMPLEX RHOMMF,RHOSMF,RHOLMF,RHOOMF
      COMPLEX RHOSA, RHOLA, RHOOA, RHOSF,RHOOF
      COMPLEX CMMA,  CSMA,  CLMA,  COMA
      COMPLEX CMMF,  CSMF,  CLMF,  COMF
      COMPLEX CSA,   CLA,   COA,   CSF,  COF
      COMPLEX LLARRA,LL
      DIMENSION LLARRA(48),LL(48)
      DIMENSION F(500),CIRCLE(24,7),LINE(24,2)
      CHARACTER*3 FCH1
      CHARACTER*4 FCH2
C
      PI=3.141592654  
      VALUE=0.0
      PHASE=0.0
      CPHASE=CMPLX(0.0,0.0)
      Z0=50.0
C       
C EXT OPEN(5,FILE='INPUT.TXT',ACTION='READ')
      OPEN(5,FILE='INPUT.TXT')
      READ(5,*)INDEX             
C     INDEX=0->RHO, INDEX=1->ZINP
      READ(5,*)NF
C     NF:Number of frequencies      
      READ(5,*)DS,DL,DOO,DFS,DFO 
C     DFS,DFO IN DEGREES
      READ(5,*)DIGIT             
C     HOW MANY DIGITS IN LSD POSITION
      CLOSE(5)
      IF((INDEX.GT.1).OR.(INDEX.LT.0))GOTO 5000
C
      OPEN(10,FILE='SH.SC')
      DO 100 I=1,NF,1
      READ(10,*)FF,VALUE,PHASE
      CPHASE=CMPLX(0.0,PHASE*PI/180.)
      S(I)=CMPLX(10**(VALUE/20)*CEXP(CPHASE))
  100 CONTINUE
      CLOSE(10)
C
      OPEN(11,FILE='OP.OC')
      DO 110 I=1,NF,1
      READ(11,*)FF,VALUE,PHASE
      CPHASE=CMPLX(0.0,PHASE*PI/180.)
      O(I)=CMPLX(10**(VALUE/20)*CEXP(CPHASE))
  110 CONTINUE
      CLOSE(11)
C
      OPEN(12,FILE='LD.LD')
      DO 120 I=1,NF,1
      READ(12,*)FF,VALUE,PHASE
      CPHASE=CMPLX(0.0,PHASE*PI/180.)
      L(I)=CMPLX(10**(VALUE/20)*CEXP(CPHASE))
  120 CONTINUE
      CLOSE(12)
C
      OPEN(13,FILE='ME.ME')
      DO 130 I=1,NF,1
      READ(13,*)F(I),VALUE,PHASE
      CPHASE=CMPLX(0.0,PHASE*PI/180.)
      ME(I)=10**(VALUE/20)*CEXP(CPHASE)
  130 CONTINUE
      CLOSE(13)
C
      CALL FIDZDY(NF,DIGIT,DMDB,DSDB,DLDB,DODB,DFMM,DFSM,DFLM,DFOM) 
C
C     WRITE(6,*)DMDB(2),DSDB(2),DLDB(2),DODB(2)
C     WRITE(6,*)DFMM(2),DFSM(2),DFLM(2),DFOM(2)
C       
      OPEN(26,FILE='RDEIS.TXT')
      OPEN(36,FILE='PDEIS.TXT')
      DO 140 I=1,NF,1
      STEMP=S(I)
      LTEMP=L(I)
      OTEMP=O(I)
      METEMP=ME(I)
      D      =CMPLX(0.0,0.0)
      M      =CMPLX(0.0,0.0)
      R      =CMPLX(0.0,0.0)
      RHO    =CMPLX(0.0,0.0)
      ZETA   =CMPLX(0.0,0.0)
      RHOZET =CMPLX(0.0,0.0)
      ZI     =CMPLX(0.0,0.0)
      CALL COEFFI(STEMP,LTEMP,OTEMP,METEMP,
     *            RHOMMA,RHOSMA,RHOLMA,RHOOMA,
     *            RHOMMF,RHOSMF,RHOLMF,RHOOMF,
     *            RHOSF, RHOOF, RHOSA, RHOLA,RHOOA,
     *            D,M,R,RHO)            
C      
C     WRITE(6,*)D,M,R,RHO 
      IF(INDEX.EQ.0)THEN      
C     RHO REGIONS
      CMMA=RHOMMA
      CSMA=RHOSMA
      CLMA=RHOLMA
      COMA=RHOOMA
      CMMF=RHOMMF
      CSMF=RHOSMF
      CLMF=RHOLMF
      COMF=RHOOMF
      CSF=RHOSF
      COF=RHOOF
      CSA=RHOSA
      CLA=RHOLA
      COA=RHOOA
      ELSEIF(INDEX.EQ.1)THEN  
C     ZETA REGIONS
      ZI=2*Z0/(1-RHO)**2
      ZETA=Z0*(1+RHO)/(1-RHO)
      CMMA=RHOMMA*ZI
      CSMA=RHOSMA*ZI
      CLMA=RHOLMA*ZI
      COMA=RHOOMA*ZI
      CMMF=RHOMMF*ZI
      CSMF=RHOSMF*ZI
      CLMF=RHOLMF*ZI
      COMF=RHOOMF*ZI
      CSF=RHOSF*ZI
      COF=RHOOF*ZI
      CSA=RHOSA*ZI
      CLA=RHOLA*ZI
      COA=RHOOA*ZI
      ENDIF
C
      CALL ORTHOG(CMMA,CSMA,CLMA,COMA,
     *            CMMF,CSMF,CLMF,COMF,
     *            CSF,COF,
     *            DMDB(I),DSDB(I),DLDB(I),DODB(I),
     *            DFMM(I),DFSM(I),DFLM(I),DFOM(I),
     *            DFS,DFO,
     *            LLARRA,NL)
C
      DO 150 J=1,NL,1
      LL(J)=LLARRA(J)
      LLARRA(J)=CMPLX(0.0,0.0)
  150 CONTINUE
      CALL HALFOR(NL,LL,DS,CSA,LLARRA)
      DO 160 J=1,NL,1
      LL(J)=LLARRA(J)
      LLARRA(J)=CMPLX(0.0,0.0)
  160 CONTINUE
      CALL HALFOR(NL,LL,DOO,COA,LLARRA)
      DO 170 J=1,NL,1
      LL(J)=LLARRA(J)
      LLARRA(J)=CMPLX(0.0,0.0)
  170 CONTINUE
      CALL SORT(NL,LL,LLARRA)         
C
      DO 180 J=1,NL,1
      LL(J)=LLARRA(J)
      LLARRA(J)=CMPLX(0.0,0.0)
  180 CONTINUE
      NLB=NL
C                
      IF(INDEX.EQ.0)RHOZET=RHO
      IF(INDEX.EQ.1)RHOZET=ZETA
C
      CALL CIRCUL(NL,RHOZET,LL,DL,CLA,LLARRA,CIRCLE,LINE)
      CALL REDEIS(NLB,LL,DL,CLA,MINR,MAXR,MINI,MAXI)
      WRITE(26,1340)F(I),REAL(RHOZET),MINR,MAXR,IMAG(RHOZET),MINI,MAXI
      CALL PODEIS(RHOZET,LLARRA,CIRCLE,LINE,MINM,MAXM,MINA,MAXA)
      WRITE(36,1340)F(I),CABS(RHOZET),MINM,MAXM,ATAN2(IMAG(RHOZET),
     *REAL(RHOZET)),MINA,MAXA
C
  300 IF(F(I).LT.1000) THEN
      WRITE(FCH1,'(I3)')INT(F(I))
      OPEN(16,FILE=FCH1//'R.TXT')
      OPEN(46,FILE=FCH1//'A.TXT')
      ELSE
      WRITE(FCH2,'(I4)')INT(F(I))
      OPEN(16,FILE=FCH2//'R.TXT')
      OPEN(46,FILE=FCH2//'A.TXT')
      ENDIF
      WRITE(16,1300)0,REAL(RHOZET),IMAG(RHOZET)
      DO 200 J=1,NL,1
  200 WRITE(16,1300)J,REAL(LLARRA(J)),IMAG(LLARRA(J))
C
      DO 210 J=1,24,1
  210 WRITE(16,1320)J,LINE(J,1),LINE(J,2)
      WRITE(16,1300)1,MINR,MAXR       
      WRITE(16,1300)2,MINI,MAXI
      WRITE(16,1300)3,MINM,MAXM       
      WRITE(16,1300)4,MINA,MAXA
C
      DO 220 J=1,24,1
  220 WRITE(46,1330)J,INT(CIRCLE(J,1)),INT(CIRCLE(J,2)),CIRCLE(J,3),
     *CIRCLE(J,4),CIRCLE(J,5),CIRCLE(J,6),CIRCLE(J,7)
      CLOSE(16)
      CLOSE(46)
  140 CONTINUE
      CLOSE(26)
      CLOSE(36) 
C
C      WRITE(6,*)F,VALUE,PHASE
C      WRITE(6,*)S,L,O,ME 
C      WRITE(6,*)"------------"
C      WRITE(6,*)D,M,R 
C      WRITE(6,*)"------------"
C      WRITE(6,*)RHO
C      WRITE(6,*)"------------"
C      WRITE(6,*)"dS=  ",RHOSA
C      WRITE(6,*)"dL=  ",RHOLA
C      WRITE(6,*)"dO=  ",RHOOA
C      WRITE(6,*)"dfS= ",RHOSF
C      WRITE(6,*)"dfO= ",RHOOF
C      WRITE(6,*)"------------"
C      WRITE(6,*)"dmdb=",RHOMMA
C      WRITE(6,*)"dsdb=",RHOSMA
C      WRITE(6,*)"dldb=",RHOLMA
C      WRITE(6,*)"dodb=",RHOOMA
C      WRITE(6,*)"------------"
C      WRITE(6,*)"dfm= ",RHOMMF
C      WRITE(6,*)"dfs= ",RHOSMF
C      WRITE(6,*)"dfl= ",RHOLMF
C      WRITE(6,*)"dfo= ",RHOOMF
C      WRITE(6,*)"------------"
C      WRITE(6,1215)DS
C      WRITE(6,1216)DL
C      WRITE(6,1217)DOO
C      WRITE(6,1218)DFS
C      WRITE(6,1219)DFO
C      WRITE(6,*)"------------"
C      WRITE(6,1220)DMDB
C      WRITE(6,1221)DSDB
C      WRITE(6,1222)DLDB
C      WRITE(6,1223)DODB
C      WRITE(6,*)"------------"
C      WRITE(6,1224)DFMM
C      WRITE(6,1225)DFSM
C      WRITE(6,1226)DFLM
C      WRITE(6,1227)DFOM
C      WRITE(6,*)"------------"
C
 1200 FORMAT(1X,I4)
C1215 FORMAT(1X,"dS  =",F7.4)
C1216 FORMAT(1X,"dL  =",F7.4)
C1217 FORMAT(1X,"dO  =",F7.4)
C1218 FORMAT(1X,"dFS =",F7.4)
C1219 FORMAT(1X,"dFO =",F7.4)
C1220 FORMAT(1X,"dmdb=", F7.4)
C1221 FORMAT(1X,"dsdb=", F7.4)
C1222 FORMAT(1X,"dldb=", F7.4)
C1223 FORMAT(1X,"dodb=", F7.4)
C1224 FORMAT(1X,"dfm =", F7.4)
C1225 FORMAT(1X,"dfs =", F7.4)
C1226 FORMAT(1X,"dfl =", F7.4)
C1227 FORMAT(1X,"dfo =", F7.4)
 1300 FORMAT(1X,I2,2(1X,F16.7))
 1310 FORMAT(1X,F7.2)
 1320 FORMAT(1X,3(1X,I3))
 1330 FORMAT(1X,3(1X,I3), 5(1X,F16.7))
 1340 FORMAT(1X,F7.2,6(1X,F16.7))
 1350 FORMAT(2X,I1)
 5000 CONTINUE
      END
