C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C ORTHOG.FOR - 24.09.2019 - OpenWatcom FORTRAN
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Copyright (c) 2009-2019 Nikolitsa Giannopoulou OE3ZGN|SV7DMC and      
C Petros Zimourtopoulos OE3ZZP|SV7BAX - Austria EU - www.op4.eu -       
C                                                                       
C Permission is hereby granted, free of charge, to any person obtaining 
C a copy of this software and associated documentation files (the       
C "Software"), to deal in the Software without restriction, including   
C distribute, sublicense, and/or sell copies of the Software, and to    
C permit persons to whom the Software is furnished to do so, subject to 
C the following conditions:                                             
C                                                                      
C The above copyright notice and this permission notice shall be        
C included in all copies or substantial portions of the Software.       
C                                                                       
C THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       
C EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    
C MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
C IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY  
C CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,  
C TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE     
C SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C /F/L/O/S/S/ Free Libre Open Source Software under "The MIT License"   
C approved by OSI Open Source Initiative www.opensource.org/licenses/MIT
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Current Version : 20190924 - OpenWatcom : 1.9 
C First   Version : 20093003 - OpenWatcom : 1.8 
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C2345678901234567890123456789012345678901234567890123456789012345VENEX72
      SUBROUTINE ORTHOG(RHOMMA,RHOSMA,RHOLMA,RHOOMA,
     *                  RHOMMF,RHOSMF,RHOLMF,RHOOMF,
     *                  RHOSF, RHOOF,
     *                  DMDBI,DSDBI,DLDBI,DODBI,
     *                  DFMMI,DFSMI,DFLMI,DFOMI,
     *                  DFS,DFO,
     *                  LLARRA,NL)
C
      REAL DPL
      COMPLEX RHOMMA,RHOSMA,RHOLMA,RHOOMA
      COMPLEX RHOMMF,RHOSMF,RHOLMF,RHOOMF
      COMPLEX RHOSF, RHOOF
      REAL DMDBI,DSDBI,DLDBI,DODBI
      REAL DFMMI,DFSMI,DFLMI,DFOMI
      REAL DFS,DFO
      COMPLEX H1A,H1B,H2A,H2B
      DIMENSION LARRAY(48,2),FL(48),E1(48),FL2(48)
      REAL LARRAY,FL,E1,FL2,E3
      DIMENSION LLARRA(48),K0(8),P3(48),E3(48),H3(48)
      COMPLEX LLARRA,H3,K0,E0
      INTEGER I,J,K,NL,P3,II,E2
      REAL TEMP,IM,RE,PI,MAX,E0ARG
C
      PI=3.141592654  
      DO 1 I=1,48,1
      DO 1 J=1,2,1
      LARRAY(I,J)=0.0
    1 CONTINUE
      DO 2 I=1,48,1
      LLARRA(I)=CMPLX(0.0,0.0)
      FL(I) =0.0
      FL2(I)=0.0
      E1(I) =0.0
      P3(I) =0
      E3(I) =0.0
      H3(I) =(0.0,0.0)
    2 CONTINUE
      DO 3 I=1,8,1
    3 K0(I)=(0.0,0.0)
c
      H1A=RHOMMA*DMDBI
      H1B=RHOSMA*DSDBI
      H2A=H1A+H1B
      H2B=H1A-H1B  
C
      LARRAY(1,1)= REAL(H2A)  
      LARRAY(1,2)= IMAG(H2A)
      LARRAY(2,1)=-REAL(H2A)
      LARRAY(2,2)=-IMAG(H2A)
      LARRAY(3,1)= REAL(H2B)
      LARRAY(3,2)= IMAG(H2B)
      LARRAY(4,1)=-REAL(H2B)
      LARRAY(4,2)=-IMAG(H2B)
C
      LLARRA(1)= H2A         
      LLARRA(2)=-H2A
      LLARRA(3)= H2B
      LLARRA(4)=-H2B
C
      IM=0.
      RE=0.
      NL=4
      DO 100 I=1,NL,1
      IM=IMAG(LLARRA(I))
      RE=REAL(LLARRA(I))
      FL(I)=ATAN2(IM,RE)
  100 CONTINUE
C     FROM THE 3RD TO 10TH COEFFICIENT
      K0(1)=RHOLMA*DLDBI        
      K0(2)=RHOOMA*DODBI
      K0(3)=RHOMMF*DFMMI*PI/180.
      K0(4)=RHOSMF*DFSMI*PI/180.
      K0(5)=RHOLMF*DFLMI*PI/180.
      K0(6)=RHOOMF*DFOMI*PI/180.
      K0(7)=RHOSF*DFS*PI/180.
      K0(8)=RHOOF*DFO*PI/180.
C
      K=1
 1000 CONTINUE
      E0=K0(K)
      DO 110 I=1,NL,1
      E1(I)=DPL(LARRAY(I,1),LARRAY(I,2),REAL(E0),IMAG(E0))
  110 CONTINUE
      E2=1
      MAX=0.0
      DO 120 I=1,NL,2
      TEMP=E1(I)
      IF (TEMP.GT.MAX) THEN
      MAX=TEMP
      E2=I
      ENDIF
  120 CONTINUE
C
      DO 130 I=1,NL,1
      FL2(I)=FL(I)
  130 CONTINUE
C
      IF ((0.LT.FL(E2)).AND.(FL(E2).LE.PI)) THEN
      TEMP=FL(E2+1)
      FL2(E2+1)=FL(E2)
      FL2(E2)=TEMP
      ENDIF
C
      II=0
      DO 140 I=1,NL,1
      IF ((FL2(E2).LE.FL(I)).AND.(FL(I).LE.FL2(E2+1))) THEN
      II=II+1
      P3(II)=I
      ENDIF
  140 CONTINUE
      E0ARG=ATAN2(IMAG(E0),REAL(E0))
      DO 150 I=1,II,1
      J=P3(I)
      IF ((FL2(E2).LT.E0ARG).AND.(E0ARG.LT.FL2(E2+1))) THEN
      H3(I)=E0+LLARRA(J)
      ELSE
      H3(I)=-E0+LLARRA(J)
      ENDIF
  150 CONTINUE
      DO 160 I=II+1,2*II,1
      H3(I)=-H3(I-II) 
  160 CONTINUE
      DO 170 I=1,2*II,1
      IM=IMAG(H3(I))
      RE=REAL(H3(I))
      E3(I)=ATAN2(IM,RE)
  170 CONTINUE
      J=1
      DO 180 I=1,II,1
      LLARRA(J)=H3(I)
      LLARRA(J+1)=-H3(I) 
      J=J+2
  180 CONTINUE
      DO 190 I=1,2*II,1
      IM=IMAG(LLARRA(I))
      RE=REAL(LLARRA(I))
      LARRAY(I,1)=RE
      LARRAY(I,2)=IM
      FL(I)=ATAN2(IM,RE)
  190 CONTINUE
C      
      NL=2*II
      K=K+1
      IF (K.LT.9)GOTO 1000
      END
