C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C SOARCS.FOR - OpenWatcom FORTRAN
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Copyright (c) 2009-2019 Nikolitsa Giannopoulou OE3ZGN|SV7DMC and      
C Petros Zimourtopoulos OE3ZZP|SV7BAX - Austria EU - www.op4.eu -       
C                                                                       
C Permission is hereby granted, free of charge, to any person obtaining 
C a copy of this software and associated documentation files (the       
C "Software"), to deal in the Software without restriction, including   
C distribute, sublicense, and/or sell copies of the Software, and to    
C permit persons to whom the Software is furnished to do so, subject to 
C the following conditions:                                             
C                                                                      
C The above copyright notice and this permission notice shall be        
C included in all copies or substantial portions of the Software.       
C                                                                       
C THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       
C EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    
C MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
C IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY  
C CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,  
C TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE     
C SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C /F/L/O/S/S/ Free Libre Open Source Software under "The MIT License"   
C approved by OSI Open Source Initiative www.opensource.org/licenses/MIT
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Current Version : 20190924 - OpenWatcom : 1.9 
C First   Version : 20093003 - OpenWatcom : 1.8 
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C2345678901234567890123456789012345678901234567890123456789012345VENEX72
      SUBROUTINE SOARCS(K,ARG,PHMIN,PHMAX,MINAA,MAXAA)
      INTEGER I,J,K,JJ
      REAL ARG,MINAA,MAXAA,PI
      REAL PHASE,PHMIN,PHMAX
      DIMENSION ARG(K),PHMIN(K),PHMAX(K)
C
      PI=3.141592654  
      MINAA=-99999999
      MAXAA=99999999
      DO 1 I=1,K,1
      PHMIN(I)=0.0
    1 PHMAX(I)=0.0      
      J=1
      JJ=1
      DO 10 I=1,K,1
      PHASE=ARG(I)
      IF ((PHASE.GT.(-PI)).AND.(PHASE.LT.(-PI/2)))THEN
      PHMIN(J)=PHASE
      J=J+1
      ENDIF
      IF((PHASE.GT.PI/2).AND.(PHASE.LE.PI))THEN
      PHMAX(JJ)=PHASE
      JJ=JJ+1
      ENDIF
   10 CONTINUE
      DO 20 I=1,J-1,1
      IF (PHMIN(I).GT.MINAA)THEN 
      MINAA=PHMIN(I)
      ENDIF
   20 CONTINUE
      DO 30 I=1,JJ-1,1
      IF (PHMAX(I).LT.MAXAA)THEN
      MAXAA=PHMAX(I)
      ENDIF
   30 CONTINUE
      END
