C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C SORT.FOR - OpenWatcom FORTRAN
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Copyright (c) 2009-2019 Nikolitsa Giannopoulou OE3ZGN|SV7DMC and      
C Petros Zimourtopoulos OE3ZZP|SV7BAX - Austria EU - www.op4.eu -       
C                                                                       
C Permission is hereby granted, free of charge, to any person obtaining 
C a copy of this software and associated documentation files (the       
C "Software"), to deal in the Software without restriction, including   
C distribute, sublicense, and/or sell copies of the Software, and to    
C permit persons to whom the Software is furnished to do so, subject to 
C the following conditions:                                             
C                                                                      
C The above copyright notice and this permission notice shall be        
C included in all copies or substantial portions of the Software.       
C                                                                       
C THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       
C EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    
C MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
C IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY  
C CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,  
C TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE     
C SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C /F/L/O/S/S/ Free Libre Open Source Software under "The MIT License"   
C approved by OSI Open Source Initiative www.opensource.org/licenses/MIT
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C Current Version : 20190924 - OpenWatcom : 1.9 
C First   Version : 20093003 - OpenWatcom : 1.8 
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
C2345678901234567890123456789012345678901234567890123456789012345VENEX72
      SUBROUTINE SORT(NL,LL,LLARRA)
      INTEGER I,J,NL,NLTEMP,K,PO
      REAL IM,RE,FL,E3,MIN,TEMP
      COMPLEX LL,LLARRA
      DIMENSION LL(48),LLARRA(48)
      DIMENSION FL(48),E3(48),PO(48)
C     
      NLTEMP=NL
      IM=0.0
      RE=0.0
      DO 10 I=1,NL,1
      E3(I)=0.0
      FL(I)=0.0
      PO(I)=0
   10 CONTINUE
      DO 20 I=1,NL,1
      IM=IMAG(LL(I))
      RE=REAL(LL(I))
      FL(I)=ATAN2(IM,RE)
   20 CONTINUE
      J=1
      K=0
   25 K=K+1
      MIN=99999
      DO 30 I=1,NLTEMP,1
      TEMP=FL(I)
      IF (TEMP.LT.MIN) THEN
      MIN=TEMP
      PO(K)=I   
      ENDIF     
   30 CONTINUE
      FL(PO(K))=99999
      J=J+1
      NL=NL-1
      IF (NL.GT.0)GOTO 25
      NL=NLTEMP
      DO 40 I=1,NL,1
      LLARRA(I)=LL(PO(I))
   40 CONTINUE
      END
